看题目。。。
看解题报告。。。
敲。。。。
大致题意:
给定两个四位素数a b,要求把a变换到b
变换的过程要保证 每次变换出来的数都是一个 四位素数,而且当前这步的变换所得的素数 与 前一步得到的素数 只能有一个位不同,而且每步得到的素数都不能重复。
求从a到b最少需要的变换次数。无法变换则输出Impossible
Prime Path
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 9564 | Accepted: 5497 |
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. — It is a matter of security to change such things every now and then, to keep the enemy in the dark. — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3 1033 8179 1373 8017 1033 1033
Sample Output
6 7 0
我用的STL的queue和BFS
代码如下:
1 #include<stdio.h> 2 #include<string.h> 3 #include<stdlib.h> 4 #include<queue> 5 using namespace std; 6 queue<struct node>que; 7 8 struct node 9 { 10 int prime; 11 int step; 12 }; 13 14 int n,m; 15 int vis[15000]; 16 int prim(int digit) 17 { 18 if(digit==2 || digit==3) 19 return 1; 20 else if(digit<=1 || digit%2==0) 21 return 0; 22 else if(digit>3) 23 { 24 for(int i=3; i*i<=digit; i+=2) 25 if(digit%i==0) 26 return 0; 27 return 1; 28 } 29 } 30 31 int bfs() 32 { 33 int i; 34 struct node k; 35 while(!que.empty()) 36 que.pop(); 37 k.prime=n; 38 k.step=0; 39 que.push(k); 40 vis[n]=1; 41 while(!que.empty()) 42 { 43 struct node s=que.front(); 44 que.pop(); 45 if(s.prime==m) 46 { 47 printf("%d ",s.step); 48 return 0; 49 } 50 int x=s.prime%10; 51 int y=(s.prime/10)%10; 52 for(i=1; i<=9; i+=2) 53 { 54 int a=(s.prime/10)*10+i; 55 if(a!=s.prime&&!vis[a]&&prim(a)) 56 { 57 vis[a]=1; 58 k.prime=a; 59 k.step=s.step+1; 60 que.push(k); 61 } 62 } 63 for(i=0; i<=9; i++) //枚举十位 64 { 65 int a=(s.prime/100)*100+i*10+x; 66 if(a!=s.prime && !vis[a] &&prim(a)) 67 { 68 vis[a]=1; 69 k.prime=a; 70 k.step=s.step+1; 71 que.push(k); 72 } 73 } 74 75 for(i=0; i<=9; i++) //枚举百位 76 { 77 int a=(s.prime/1000)*1000+i*100+y*10+x; 78 if(a!=s.prime&&vis[a]==0&&prim(a)) 79 { 80 vis[a]=1; 81 k.prime=a; 82 k.step=s.step+1; 83 que.push(k); 84 } 85 } 86 for(i=1; i<=9; i++) //枚举的千位,保证四位数,千位最少为1 87 { 88 int a=s.prime%1000+i*1000; 89 if(a!=s.prime && !vis[a] && prim(a)) 90 { 91 vis[a]=1; 92 k.prime=a; 93 k.step=s.step+1; 94 que.push(k); 95 } 96 } 97 } 98 printf("Impossible "); 99 return 0; 100 } 101 int main() 102 { 103 int t; 104 scanf("%d",&t); 105 while(t--) 106 { 107 scanf("%d %d",&n,&m); 108 memset(vis,0,sizeof(vis)); 109 bfs(); 110 } 111 return 0; 112 }